#!/usr/bin/perl

use CGI::Carp "fatalsToBrowser";
use CGI qw(:standard);
use lib::MARC;
use strict;

use vars qw(
			$ENV
			%conf
			%MARC_config
			$cgi
			$MARC
			$copies
			$next_control_number
			$plain_cn
			);

use subs qw(

			);

$cgi = new CGI;

%conf = lib::MARC->conf_parser("../config") or die ("Cannot open config-file: $!");
my %MARCsyn_config = lib::MARC->conf_parser("../MARCsyn_config") or die ("Cannot open MARCsyn_config-file: $!");
%MARC_config = lib::MARC->conf_parser("../MARC_config") or die ("Cannot open MARC_config-file: $!");

lib::MARC->dbInit(%conf);

if(lib::MARC->verify_session($cgi, %conf) && lib::MARC->verify_request($cgi, %conf))
{
	$MARC = lib::MARC->new($cgi->param('raw_marc'));
	$MARC->marc_timestamp();
	#$MARC->fetch_location_name($cgi);

	if($cgi->param('native_cn')) {
		$MARC->control_number('existent', $cgi->param('native_cn'));
	}
	else {
		$MARC->control_number('generate', $MARCsyn_config{'control_number_length'});
	}
	
	$MARC->replace($cgi, $MARCsyn_config{'native_control_number_identifier'}, %MARC_config);
	$MARC->write(%conf);
	
	if(!$cgi->param('copies') or $cgi->param('copies') eq ''){
		$copies = 1;
	}
	else {
		$copies = $cgi->param('copies');
	}
	
	my @ids = $MARC->database_update($copies);
	$MARC->zebraidx(%conf);
	lib::MARC->dbEnd;

	my $ids = join(",", @ids);

	my $url = "../".$cgi->param('from_page').".php?id=".$cgi->param('id')."&auth=".$cgi->param('auth')."&result=add_success&book_id=".$ids;
	print redirect($url)
}
else {
	die "<h1>You are not supposed to bere, right?</h1>";
}

